Index: /java/main/src/main/java/com/framsticks/params/Group.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/Group.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/Group.java	(revision 87)
@@ -4,9 +4,15 @@
 import java.util.List;
 
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+
 /**
  * @author Piotr Sniegowski
  */
+@FramsClassAnnotation
 public class Group {
-	String name;
+
+	@ParamAnnotation
+	protected String name;
 
 	/**
@@ -40,9 +46,4 @@
 	}
 
-	/*
-			 * (non-Javadoc)
-			 *
-			 * @see java.lang.Object#toString()
-			 */
 	@Override
 	public String toString() {
@@ -50,3 +51,11 @@
 	}
 
+	/**
+	 * @return the name
+	 */
+	@ParamAnnotation
+	public String getName() {
+		return name;
+	}
+
 }
Index: /java/main/src/main/java/com/framsticks/params/ListAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ListAccess.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/ListAccess.java	(revision 87)
@@ -75,3 +75,9 @@
 	}
 
-}
+	//TODO it could actually be used also
+	@Override
+	public boolean tryAutoAppend(Object object) {
+		return false;
+	}
+
+};
Index: /java/main/src/main/java/com/framsticks/params/Param.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/Param.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/Param.java	(revision 87)
@@ -2,6 +2,8 @@
 
 
-import com.framsticks.params.types.DecimalParam;
-import com.framsticks.params.types.StringParam;
+import javax.annotation.concurrent.Immutable;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
 
 /**
@@ -14,35 +16,45 @@
  * @author Piotr Śniegowski
  */
+@Immutable
+@FramsClassAnnotation(id = "prop", name = "prop")
 public abstract class Param {
 
 	/** The parameter id. */
-	protected String id;
+	protected final String id;
 
+	//TODO
 	/**
 	 * The parameter internal id. It's set by a user to use user's own getId in
 	 * code
 	 */
-	protected String internalId;
+	protected final String internalId;
 
 	/** The parameter name. */
-	protected String name;
+	protected final String name;
 
 	/** The help (description) concerning parameter. */
-	protected String help;
+	protected final String help;
 
 	/** The number of group, that parameter belongs to. */
-	protected Integer group;
+	protected final Integer group;
 
 	/** The getFlags stored as a bit sum. */
-	protected Integer flags;
+	protected final Integer flags;
 
+	//TODO
 	/** The variable determining whether the parameter is an extra parameter. */
-	protected Integer extra;
+	protected final Integer extra;
 
-
-	public Param() {
-
+	public Param(ParamBuilder builder) {
+		id = builder.getId();
+		internalId = builder.getInternalId();
+		name = builder.getName();
+		help = builder.getHelp();
+		group = builder.getGroup();
+		flags = builder.getFlags();
+		extra = 0;
 	}
 
+	@ParamAnnotation
 	public String getId() {
 		return id;
@@ -53,16 +65,20 @@
 	}
 
+	@ParamAnnotation
 	public String getName() {
 		return name;
 	}
 
+	@ParamAnnotation
 	public String getHelp() {
 		return help;
 	}
 
+	@ParamAnnotation
 	public Integer getGroup() {
 		return group;
 	}
 
+	@ParamAnnotation
 	public Integer getFlags() {
 		return flags;
@@ -79,8 +95,4 @@
 	public Integer getExtra() {
 		return extra;
-	}
-
-	public void setInternalId(String internalId) {
-		this.internalId = internalId;
 	}
 
@@ -104,16 +116,11 @@
 	}
 
-	public static FramsClass getFramsClass() {
-		return new FramsClass("prop", "prop", null)
-			.append(Param.build().id("name").name("Name").type(StringParam.class).finish())
-			.append(Param.build().id("id").name("Id").type(StringParam.class).finish())
-			.append(Param.build().id("type").name("Type").type(StringParam.class).finish())
-			.append(Param.build().id("help").name("Help").type(StringParam.class).finish())
-			.append(Param.build().id("flags").name("Flags").type(DecimalParam.class).finish());
-	}
-
 	public static ParamBuilder build() {
 		return new ParamBuilder();
 	}
 
+	public static ParamBuilder build(FramsClassBuilder builder) {
+		return new ParamBuilder(builder);
+	}
+
 }
Index: /java/main/src/main/java/com/framsticks/params/ParamBuilder.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ParamBuilder.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/ParamBuilder.java	(revision 87)
@@ -4,11 +4,12 @@
 import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.params.types.*;
-import com.framsticks.util.lang.Numbers;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.lang.Strings;
 
 import org.apache.log4j.Logger;
 
-import java.util.ArrayList;
+import java.lang.reflect.InvocationTargetException;
 import java.util.Arrays;
-
+import java.util.List;
 
 /**
@@ -56,9 +57,71 @@
 	private Class<? extends Param> paramType;
 
-	private Param param;
-	private PrimitiveParam primitiveParam;
-	private String typeString;
+	private Object min;
+
+	private Object max;
+
+	private Object def;
+
+	String containedTypeName;
+
+	protected FramsClassBuilder classBuilder;
 
 	public ParamBuilder() {
+		this(null);
+	}
+
+
+	/**
+	 * @param classBuilder
+	 */
+	public ParamBuilder(FramsClassBuilder classBuilder) {
+		this.classBuilder = classBuilder;
+	}
+
+
+	/**
+	 * @return the min
+	 */
+	public Object getMin() {
+		return min;
+	}
+
+	/**
+	 * @return the max
+	 */
+	public Object getMax() {
+		return max;
+	}
+
+	/**
+	 * @return the def
+	 */
+	public Object getDef() {
+		return def;
+	}
+
+	public String getContainedTypeName() {
+		return Strings.notEmpty(containedTypeName) ? containedTypeName : null;
+	}
+
+	/**
+	 * @return the enumValues
+	 */
+	public List<String> getEnumValues() {
+		return enumValues;
+	}
+
+	/**
+	 * @return the procedureSignature
+	 */
+	public String getProcedureSignature() {
+		return procedureSignature;
+	}
+
+	/**
+	 * @return the uid
+	 */
+	public String getUid() {
+		return uid;
 	}
 
@@ -70,13 +133,10 @@
 	 *             when Param getType is not defined
 	 */
-	public Param finish()  {
-		assert param != null;
-		param.id = id;
-		param.name = name;
-		param.help = help;
-		param.group = group;
-		param.flags = flags;
-		param.internalId = internalId;
-		return param;
+	public Param finish() {
+		try {
+			return paramType.getConstructor(ParamBuilder.class).newInstance(this);
+		} catch (InstantiationException | IllegalAccessException | IllegalArgumentException | InvocationTargetException | NoSuchMethodException | SecurityException e) {
+			throw new FramsticksException().msg("failed to create param").cause(e).arg("name", name);
+		}
 	}
 
@@ -87,27 +147,13 @@
 	}
 
-	protected <T extends Param> ParamBuilder internalSetType(Class<? extends Param> type, T param) {
-		this.paramType = type;
-		this.param = param;
-		if (param instanceof PrimitiveParam) {
-			primitiveParam = (PrimitiveParam) param;
-		}
-		typeString = param.getFramsTypeName();
-		return this;
-	}
-
 	public <T extends Param> ParamBuilder type(Class<T> type) {
 		assert type != null;
-		try {
-			return internalSetType(type, type.newInstance());
-		} catch (InstantiationException | IllegalAccessException e) {
-			e.printStackTrace();
-		}
-		return this;
-	}
-
-	public <T extends Param> ParamBuilder type(T param) {
-		return internalSetType(param.getClass(), param);
-	}
+		this.paramType = type;
+		return this;
+	}
+
+	// public <T extends Param> ParamBuilder type(T param) {
+	//	return internalSetType(param.getClass(), param);
+	// }
 
 
@@ -120,4 +166,11 @@
 	}
 
+	/**
+	 * @return the internalId
+	 */
+	public String getInternalId() {
+		return internalId;
+	}
+
 	public ParamBuilder setInternalId(String internalId) {
 		this.internalId = internalId;
@@ -144,25 +197,26 @@
 
 	protected <T extends Number> void parseMinMaxDefNumber(Class<T> type, String second, String third) {
-		if (primitiveParam == null) {
-			log.warn("param is not a primitive param");
-			return;
-		}
 		if (second != null) {
-			this.primitiveParam.min = Numbers.parse(second, type);
-			if (this.primitiveParam.min == null) {
-				log.warn("value of min attribute was invalid");
-			}
+			min = second;
 		}
 		if (third != null) {
-			this.primitiveParam.max = Numbers.parse(third, type);
-			if (this.primitiveParam.max == null) {
-				log.warn("value of min attribute was invalid");
-			}
-		}
-	}
+			max = third;
+		}
+	}
+
+	protected List<String> enumValues;
+
+	public ParamBuilder enums(List<String> values) {
+		enumValues = values;
+		return type(EnumParam.class);
+	}
+
+	protected String procedureSignature;
+
+	protected String uid;
 
 	@ParamAnnotation
 	public ParamBuilder type(String type) {
-		typeString = type;
+		// typeString = type;
 
 		log.trace("parsing type: " + type);
@@ -175,16 +229,11 @@
 		switch (first.charAt(0)) {
 			case 'o': {
-				type(new ObjectParam(second != null ? second : first.substring(1)));
+				containedTypeName = second != null ? second : first.substring(1);
+				type(ObjectParam.class);
 				break;
 			}
 			case 'p': {
-				ProcedureParam procedureParam = new ProcedureParam();
-				String signature = type.substring(1);
-				try {
-					procedureParam.parseSignature(signature);
-				} catch (Exception e) {
-					log.error("invalid procedure signature '" + signature + "': " + e);
-				}
-				type(procedureParam);
+				procedureSignature = type.substring(1);
+				type(ProcedureParam.class);
 				break;
 			}
@@ -193,5 +242,5 @@
 				int tildeIndex = type.indexOf("~");
 				if (tildeIndex != -1) {
-					type(new EnumParam(new ArrayList<String>(Arrays.asList(type.substring(tildeIndex + 1).split("~")))));
+					enums(Arrays.asList(type.substring(tildeIndex + 1).split("~")));
 				} else {
 					if (first.length() >= 2) {
@@ -214,9 +263,9 @@
 						type(BooleanParam.class);
 					}
-					if (param == null) {
+					if (paramType == null) {
 						type(DecimalParam.class);
 					}
 				}
-				if (this.param instanceof DecimalParam) {
+				if (DecimalParam.class.isAssignableFrom(this.paramType)) {
 					parseMinMaxDefNumber(Integer.class, second, third);
 				}
@@ -243,5 +292,11 @@
 			}
 			case 'l': {
-				type(third != null ? new UniqueListParam(second, third) : new ArrayListParam(second));
+				containedTypeName = second;
+				if (third != null) {
+					type(UniqueListParam.class);
+					uid = third;
+				} else {
+					type(ArrayListParam.class);
+				}
 				break;
 			}
@@ -294,5 +349,5 @@
 	@ParamAnnotation
 	public String getType() {
-		return typeString;
+		return "?";
 	}
 
@@ -304,29 +359,23 @@
 	}
 
-	public <T> ParamBuilder min(T min) {
-		if (primitiveParam != null) {
-			this.primitiveParam.min = min;
-		}
-		return this;
-	}
-
-	public <T> ParamBuilder max(T max) {
-		if (primitiveParam != null) {
-			this.primitiveParam.max = max;
-		}
-		return this;
-	}
-
-	public <T> ParamBuilder def(T def) {
-		if (def != null && primitiveParam != null) {
-			this.primitiveParam.def = def;
-		}
-		return this;
-	}
-
-	public Class<?> getStorageType() {
-		assert param != null;
-		return param.getStorageType();
-	}
+	public ParamBuilder min(Object min) {
+		this.min = min;
+		return this;
+	}
+
+	public ParamBuilder max(Object max) {
+		this.max = max;
+		return this;
+	}
+
+	public ParamBuilder def(Object def) {
+		this.def = def;
+		return this;
+	}
+
+	// public Class<?> getStorageType() {
+	//	assert param != null;
+	//	return param.getStorageType();
+	// }
 
 	public Param build(String line) throws Exception {
@@ -386,5 +435,10 @@
 	}
 
-
+	public ParamBuilder defaultDef(Object def) {
+		if (this.def == null) {
+			return def(def);
+		}
+		return this;
+	}
 
 }
Index: /java/main/src/main/java/com/framsticks/params/PrimitiveParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/PrimitiveParam.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/PrimitiveParam.java	(revision 87)
@@ -1,18 +1,33 @@
 package com.framsticks.params;
 
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.lang.Numbers;
+
+import javax.annotation.concurrent.Immutable;
 
 /**
  * @author Piotr Sniegowski
  */
-public abstract class PrimitiveParam extends ValueParam {
+@Immutable
+public abstract class PrimitiveParam<S> extends ValueParam {
 
 	/** The minimum allowed value of parameter. */
-	protected Object min;
+	protected final Object min;
 
 	/** The maximum allowed value of parameter. */
-	protected Object max;
+	protected final Object max;
 
 	/** The default value of parameter. */
-	protected Object def;
+	protected final Object def;
+
+	/**
+	 * @param builder
+	 */
+	public PrimitiveParam(ParamBuilder builder) {
+		super(builder);
+		min = builder.getMin();
+		max = builder.getMax();
+		def = builder.getDef();
+	}
 
 	public void save(SinkInterface sink, Object value) {
@@ -21,12 +36,24 @@
 
 	protected <T> T tryCastAndReturn(Object value, Class<T> type) {
-		if (value == null)
+		if (value == null) {
 			return null;
+		}
 		try {
-			return type.cast(value);
+			if (type.equals(Object.class)) {
+				return type.cast(value);
+			}
+			if (value instanceof String) {
+				if (type.equals(String.class)) {
+					return type.cast(value);
+				}
+				// if (Number.class.isAssignableFrom(type)) {
+				return Numbers.parse((String) value, type);
+				// }
+				// return null;
+			} else {
+				return type.cast(value);
+			}
 		} catch (ClassCastException e) {
-			throw new ClassCastException("property \"" + name
-					+ "\" type is \"" + value.getClass().getName()
-					+ "\", not \"" + type.getName() + "\"");
+			throw new FramsticksException().msg("failed to cast").cause(e).arg("param", this).arg("actual", value.getClass()).arg("requested", type);
 		}
 	}
@@ -64,5 +91,5 @@
 	 * @throws ClassCastException the class cast exception, thrown when given getType is incorrect
 	 */
-	public <T> T getDef(Class<T> type) throws ClassCastException {
+	public <T> T getDef(Class<T> type) {
 		return tryCastAndReturn(def, type);
 	}
Index: /java/main/src/main/java/com/framsticks/params/PropertiesAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/PropertiesAccess.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/PropertiesAccess.java	(revision 87)
@@ -27,5 +27,5 @@
 
 	public PropertiesAccess(FramsClass framsClass) {
-		setFramsClass(framsClass);
+		super(framsClass);
 	}
 
@@ -88,4 +88,8 @@
 	}
 
+	@Override
+	public boolean tryAutoAppend(Object object) {
+		return false;
+	}
 
 }
Index: /java/main/src/main/java/com/framsticks/params/ReflectionAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 87)
@@ -4,10 +4,15 @@
 import java.lang.reflect.InvocationTargetException;
 import java.lang.reflect.Method;
+import java.util.Collections;
 import java.util.HashMap;
 import java.util.Map;
 
+import javax.annotation.concurrent.Immutable;
+
 import org.apache.log4j.Logger;
 
+import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.util.FramsticksException;
+import com.framsticks.util.lang.Pair;
 
 import static com.framsticks.util.lang.Containers.*;
@@ -22,28 +27,146 @@
  */
 public class ReflectionAccess extends SimpleAbstractAccess {
-	private final static Logger log = Logger.getLogger(ReflectionAccess.class
-			.getName());
+	private final static Logger log = Logger.getLogger(ReflectionAccess.class.getName());
 
 	protected final Class<?> reflectedClass;
+	protected final Backend backend;
+
 	private Object object;
 
-
-	protected interface ReflectedSetter {
-		public <T> void set(Object object, T value) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;
-	}
-
-	protected interface ReflectedGetter {
-		public abstract <T> T get(Object object, Class<T> type) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;
-	}
-
-	protected static class ReflectedValueParam {
-		public ReflectedSetter setter;
-		public ReflectedGetter getter;
-	}
-
-	protected final Map<ValueParam, ReflectedValueParam> reflectedValueParams = new HashMap<>();
+	@Immutable
+	public static class Backend {
+
+		protected static Map<Pair<Class<?>, FramsClass>, Backend> synchronizedCache = Collections.synchronizedMap(new HashMap<Pair<Class<?>, FramsClass>, Backend>());
+
+		public static class ReflectedValueParam {
+			public ReflectedSetter setter;
+			public ReflectedGetter getter;
+		}
+
+		public interface ReflectedSetter {
+			public <T> void set(Object object, T value) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;
+		}
+
+		public interface ReflectedGetter {
+			public abstract <T> T get(Object object, Class<T> type) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;
+		}
+
+		protected final Map<ValueParam, ReflectedValueParam> params;
+		protected final Map<Class<?>, Method> autoAppendMethods;
+
+		/**
+		 * @param params
+		 */
+		public Backend(Map<ValueParam, ReflectedValueParam> params, Map<Class<?>, Method> autoAppendMethods) {
+			// this.params = Collections.unmodifiableMap(params);
+			this.params = params;
+			this.autoAppendMethods = autoAppendMethods;
+		}
+
+		public static Backend getOrCreateFor(Class<?> reflectedClass, FramsClass framsClass) {
+
+			Pair<Class<?>, FramsClass> id = new Pair<Class<?>, FramsClass>(reflectedClass, framsClass);
+			Backend backend = synchronizedCache.get(id);
+			if (backend != null) {
+				return backend;
+			}
+
+			log.debug("constructing backend for " + id);
+			final Map<ValueParam, ReflectedValueParam> params = new HashMap<>();
+
+			Map<String, ParamCandidate> candidates = ParamCandidate.getAllCandidates(reflectedClass);
+
+			try {
+				for (final ValueParam vp : filterInstanceof(framsClass.getParamEntries(), ValueParam.class)) {
+					if (!candidates.containsKey(vp.getId())) {
+						throw new ConstructionException().msg("missing candidate for param").arg("param", vp);
+					}
+					ParamCandidate pc = candidates.get(vp.getId());
+					if (pc.isReadOnly() && !vp.hasFlag(Flags.READONLY)) {
+						throw new ConstructionException().msg("readonly state conflict").arg("param", vp);
+					}
+					if (!typeMatch(pc.getRawType(), vp.getStorageType())) {
+						throw new ConstructionException().msg("types mismatch for param").arg("param", vp).arg("candidate", pc.getType()).arg("storage", vp.getStorageType());
+					}
+
+					ReflectedValueParam rvp = new ReflectedValueParam();
+					params.put(vp, rvp);
+					final boolean primitive = pc.isPrimitive();
+					if (pc.getField() != null) {
+						final Field f = pc.getField();
+						rvp.getter = new ReflectedGetter() {
+							@Override
+							public <T> T get(Object object, Class<T> type) throws IllegalArgumentException, IllegalAccessException {
+								return type.cast(f.get(object));
+							}
+						};
+						if (!pc.isFinal()) {
+							rvp.setter = new ReflectedSetter() {
+								@Override
+								public <T> void set(Object object, T value) throws IllegalArgumentException, IllegalAccessException {
+									if (value == null && primitive) {
+										throw new FramsticksException().msg("setting null to primitive value");
+									}
+									f.set(object, value);
+								}
+							};
+						}
+					} else {
+						final Method g = pc.getGetter();
+
+						rvp.getter = new ReflectedGetter() {
+							@Override
+							public <T> T get(Object object, Class<T> type) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
+								return type.cast(g.invoke(object));
+							}
+						};
+
+						if (!pc.isFinal()) {
+							final Method s = pc.getSetter();
+							rvp.setter = new ReflectedSetter() {
+								@Override
+								public <T> void set(Object object, T value) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
+									if (value == null && primitive) {
+										throw new FramsticksException().msg("setting null to primitive value");
+									}
+									s.invoke(object, value);
+								}
+							};
+						}
+					}
+				}
+			} catch (ConstructionException e) {
+				throw e.arg("java class", reflectedClass).arg("framsClass", framsClass);
+			}
+
+			Map<Class<?>, Method> autoAppendMethods = new HashMap<>();
+
+			Class<?> javaClass = reflectedClass;
+			while (javaClass != null) {
+
+				for (Method m : javaClass.getDeclaredMethods()) {
+					AutoAppendAnnotation a = m.getAnnotation(AutoAppendAnnotation.class);
+					if (a == null) {
+						continue;
+					}
+					Class<?>[] args = m.getParameterTypes();
+					if (args.length != 1) {
+						throw new ConstructionException().msg("invalid number of arguments in AutoAppend marked method").arg("method", m).arg("arguments", args.length);
+					}
+					autoAppendMethods.put(args[0], m);
+				}
+
+				javaClass = javaClass.getSuperclass();
+			}
+
+			backend = new Backend(params, autoAppendMethods);
+			synchronizedCache.put(id, backend);
+			return backend;
+		}
+
+	}
 
 	public ReflectionAccess(Class<?> reflectedClass) throws ConstructionException {
-		this(reflectedClass, FramsClassBuilder.buildForClass(reflectedClass));
+		this(reflectedClass, FramsClass.build().forClass(reflectedClass));
 	}
 
@@ -68,71 +191,8 @@
 
 	public ReflectionAccess(Class<?> reflectedClass, FramsClass framsClass) throws ConstructionException {
+		super(framsClass);
 		this.reflectedClass = reflectedClass;
-		setFramsClass(framsClass);
-
-		Map<String, ParamCandidate> candidates = ParamCandidate.getAllCandidates(reflectedClass);
-
-		try {
-			for (final ValueParam vp : filterInstanceof(framsClass.getParamEntries(), ValueParam.class)) {
-				if (!candidates.containsKey(vp.getId())) {
-					throw new ConstructionException().msg("missing candidate for param").arg("param", vp);
-				}
-				ParamCandidate pc = candidates.get(vp.getId());
-				if (pc.isReadOnly() && !vp.hasFlag(Flags.READONLY)) {
-					throw new ConstructionException().msg("readonly state conflict").arg("param", vp);
-				}
-				if (!typeMatch(pc.getRawType(), vp.getStorageType())) {
-					throw new ConstructionException().msg("types mismatch for param").arg("param", vp).arg("candidate", pc.getType()).arg("storage", vp.getStorageType());
-				}
-
-				ReflectedValueParam rvp = new ReflectedValueParam();
-				reflectedValueParams.put(vp, rvp);
-				final boolean primitive = pc.isPrimitive();
-				if (pc.getField() != null) {
-					final Field f = pc.getField();
-					rvp.getter = new ReflectedGetter() {
-						@Override
-						public <T> T get(Object object, Class<T> type) throws IllegalArgumentException, IllegalAccessException {
-							return type.cast(f.get(object));
-						}
-					};
-					if (!pc.isFinal()) {
-						rvp.setter = new ReflectedSetter() {
-							@Override
-							public <T> void set(Object object, T value) throws IllegalArgumentException, IllegalAccessException {
-								if (value == null && primitive) {
-									throw new FramsticksException().msg("setting null to primitive value");
-								}
-								f.set(object, value);
-							}
-						};
-					}
-				} else {
-					final Method g = pc.getGetter();
-
-					rvp.getter = new ReflectedGetter() {
-						@Override
-						public <T> T get(Object object, Class<T> type) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
-							return type.cast(g.invoke(object));
-						}
-					};
-
-					if (!pc.isFinal()) {
-						final Method s = pc.getSetter();
-						rvp.setter = new ReflectedSetter() {
-							@Override
-							public <T> void set(Object object, T value) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
-								if (value == null && primitive) {
-									throw new FramsticksException().msg("setting null to primitive value");
-								}
-								s.invoke(object, value);
-							}
-						};
-					}
-				}
-			}
-		} catch (ConstructionException e) {
-			throw e.arg("java class", reflectedClass).arg("framsClass", framsClass);
-		}
+		this.backend = Backend.getOrCreateFor(reflectedClass, framsClass);
+		// log.info("created ReflectionAccess " + this);
 	}
 
@@ -149,5 +209,5 @@
 				}
 
-				return reflectedValueParams.get(param).getter.get(object, type);
+				return backend.params.get(param).getter.get(object, type);
 			} catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException e) {
 				throw new FramsticksException().msg("failed to get").cause(e);
@@ -169,5 +229,5 @@
 					throw new FramsticksException().msg("no object set");
 				}
-				ReflectedSetter s = reflectedValueParams.get(param).setter;
+				Backend.ReflectedSetter s = backend.params.get(param).setter;
 				if (s == null) {
 					throw new FramsticksException().msg("trying to set final");
@@ -238,5 +298,4 @@
 	}
 
-
 	@Override
 	public ReflectionAccess cloneAccess() throws ConstructionException {
@@ -265,4 +324,19 @@
 	}
 
+	@Override
+	public boolean tryAutoAppend(Object value) {
+		assert object != null;
+		for (Map.Entry<Class<?>, Method> a : backend.autoAppendMethods.entrySet()) {
+			if (a.getKey().isAssignableFrom(value.getClass())) {
+				try {
+					a.getValue().invoke(object, value);
+					return true;
+				} catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException e) {
+					throw new FramsticksException().msg("failed to auto append").cause(e).arg("value", value).arg("into object", object).arg("with method", a.getValue());
+				}
+			}
+		}
+		return false;
+	}
 }
 
Index: /java/main/src/main/java/com/framsticks/params/Registry.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/Registry.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/Registry.java	(revision 87)
@@ -5,6 +5,9 @@
 import com.framsticks.params.annotations.FramsClassAnnotation;
 
+import java.util.Collections;
 import java.util.HashMap;
+import java.util.HashSet;
 import java.util.Map;
+import java.util.Set;
 
 /**
@@ -14,25 +17,63 @@
 	private static final Logger log = Logger.getLogger(Registry.class.getName());
 
-	protected final Map<String, Class<?>> reflectedClasses = new HashMap<String, Class<?>>();
-	protected final Map<String, String> invertedReflectedClasses = new HashMap<String, String>();
-	protected final Map<String, FramsClass> infoCache = new HashMap<String, FramsClass>();
+	public static class DoubleSet<K1, K2, V> {
+		protected final Map<K1, V> byId = new HashMap<>();
+		protected final Map<K2, V> byName = new HashMap<>();
+		protected final Set<V> values = new HashSet<>();
 
-	public final void registerReflectedClass(String name, String id, String className) {
-		try {
-			registerReflectedClass(name, id, Class.forName(className));
-		} catch (ClassNotFoundException e) {
-			log.fatal("class not found during registration: " + e);
+		public int size() {
+			return values.size();
+		}
+
+		public void put(K1 id, K2 name, V value) {
+			values.add(value);
+			if (id != null) {
+				byId.put(id, value);
+			}
+			if (name != null) {
+				byName.put(name, value);
+			}
+		}
+
+		public boolean containsValue(V value) {
+			return values.contains(value);
+
+		}
+
+		public boolean containsKey(String identifier) {
+			return byId.containsKey(identifier) || byName.containsKey(identifier);
+		}
+
+		public V get(String identifier) {
+			if (byId.containsKey(identifier)) {
+				return byId.get(identifier);
+			}
+			if (byName.containsKey(identifier)) {
+				return byName.get(identifier);
+			}
+			return null;
+		}
+
+		public Set<V> getValues() {
+			return Collections.unmodifiableSet(values);
 		}
 	}
 
-	public void registerReflectedClass(String name, String id,
-			Class<?> reflectedClass) {
-		if (name != null) {
-			reflectedClasses.put(name, reflectedClass);
-			invertedReflectedClasses.put(reflectedClass.getCanonicalName(), name);
-		}
-		if (id != null) {
-			reflectedClasses.put(id, reflectedClass);
-		}
+	// protected void internalRegisterClass(FramsClass framsClass, @Nullable Class<?> javaClass) {
+	// 	assert framsClass.getName() != null;
+	// 	assert framsClass.getId() != null;
+	// 	infoCacheByName.put(framsClass.getName(), framsClass);
+	// 	infoCacheById.put(framsClass.getId(), framsClass);
+
+	// 	if (javaClass != null) {
+	// 		reflectedClasses.put(framsClass, javaClass);
+	// 		infoCacheByJavaName.put(javaClass.getCanonicalName(), framsClass);
+	// 	}
+	// }
+	protected final DoubleSet<String, String, Class<?>> javaClasses = new DoubleSet<>();
+	protected final DoubleSet<String, String, FramsClass> framsClasses = new DoubleSet<>();
+
+	public void registerReflectedClass(String name, String id, Class<?> reflectedClass) {
+		javaClasses.put(id, name, reflectedClass);
 	}
 
@@ -50,6 +91,7 @@
 
 	public AccessInterface createAccess(String name, FramsClass framsClass) throws ConstructionException {
-		if (reflectedClasses.containsKey(name)) {
-			return new ReflectionAccess(reflectedClasses.get(name), framsClass);
+		assert framsClasses.containsValue(framsClass);
+		if (javaClasses.containsKey(name)) {
+			return new ReflectionAccess(javaClasses.get(name), framsClass);
 		}
 		return new PropertiesAccess(framsClass);
@@ -57,24 +99,13 @@
 
 	public void putInfoIntoCache(FramsClass framsClass) {
-		if (infoCache.containsKey(framsClass.getId())) {
-			log.info("already cached " + framsClass);
-			return;
-		}
 		log.debug("caching info for " + framsClass);
-		infoCache.put(framsClass.getId(), framsClass);
-		infoCache.put(framsClass.getName(), framsClass);
+		framsClasses.put(framsClass.getId(), framsClass.getName(), framsClass);
 	}
 
-	public FramsClass getInfoFromCache(String id) {
-		if (id == null) {
+	public FramsClass getInfoFromCache(String identifier) {
+		if (identifier == null) {
 			return null;
 		}
-		if (infoCache.containsKey(id)) {
-			return infoCache.get(id);
-		}
-		if (invertedReflectedClasses.containsKey(id)) {
-			return getInfoFromCache(invertedReflectedClasses.get(id));
-		}
-		return null;
+		return framsClasses.get(identifier);
 	}
 
@@ -102,3 +133,11 @@
 	}
 
+	public Set<Class<?>> getReflectedClasses() {
+		return javaClasses.getValues();
+	}
+
+	public Set<FramsClass> getInfoCache() {
+		return framsClasses.getValues();
+	}
+
 }
